precision mediump float;

uniform sampler2D       sTexture;

uniform bool            UseColor;
uniform mediump vec3    Color;

varying mediump vec2    TexCoord;

void main()
{
    vec4 textureColor = texture2D(sTexture, TexCoord);
    
    // Color overrides texture
    float useColor = float(UseColor); // useColor is 0 or 1
    
    // The following code line says that:
    // gl_FragColor = textureColor, if UseColor is false
    // gl_FragColor = vec4(Color * textureColor.a, textureColor.a), if UseColor is true
    gl_FragColor = (1.0 - useColor) * textureColor + useColor * vec4(Color * textureColor.a, textureColor.a);
}
