precision mediump float;

uniform sampler2D       sTexture;
uniform mediump vec2    TextureSize;
uniform sampler2D       sEffectTexture;
uniform mediump float   TimeParameter;

varying mediump vec2   TexCoord;

void main()
{
    vec2 noiseTexCoord = vec2(TexCoord.x / TextureSize.x, TexCoord.y / TextureSize.y);
    vec4 noiseVec = texture2D(sEffectTexture, noiseTexCoord);
    float noise = noiseVec.r; // noise is in [0, 1]
    float animationLength = 0.1;
    float time = TimeParameter * 1.1; // time is in [0, 1 + animationLength]
    float alpha = clamp(time - noise, 0.0, animationLength); // alpha is in [0; animationLength]
    
    alpha /= animationLength; // alpha is in [0; 1]

    gl_FragColor = texture2D(sTexture, TexCoord);
    gl_FragColor.a *= 1.0 - alpha;
}
