var Doc= function(cId){
	this.fields = new Map();
	
    this.getMsObjectId= function(){return cId;};
	
	this.getFieldByName= function(cName){return this.fields.get(cName);};
	
	this.addField= function(cName, field){return this.fields.set(cName, field);};
};


Doc.prototype= {
    get msObjectId(){return this.getMsObjectId();},
    
	get path(){
		return MSResult(msApp.sendToApp(MSParam("doc"), MSParam(this.msObjectId), MSParam("getPath"), MSParam(ArgsAsArray(arguments))));
	},
	get title(){
		return MSResult(msApp.sendToApp(MSParam("doc"), MSParam(this.msObjectId), MSParam("getTitle"), MSParam(ArgsAsArray(arguments))));
	},
	set title(val){
		msApp.sendToApp(MSParam("doc"), MSParam(this.msObjectId), MSParam("setTitle"), MSParam(ArgsAsArray(arguments)));
	},
	getField: function(cName){
		var field = this.getFieldByName(cName);
		if((field == null) || (field == undefined))
		{
			if(this.fieldExists(cName) == true)
			{
				field = new Field(this.getMsObjectId(), cName);
				this.addField(cName, field);
			}
			else
			{
				field = null;
			}
		}
		return field;
	},
	get disclosed(){
		return MSResult(msApp.sendToApp(MSParam("doc"), MSParam(this.msObjectId), MSParam("getDisclosed"), MSParam(ArgsAsArray(arguments))));
	},
	set disclosed(val){
		msApp.sendToApp(MSParam("doc"), MSParam(this.msObjectId), MSParam("setDisclosed"), MSParam(ArgsAsArray(arguments)));
	},
	setAction: function(){
		
		msApp.sendToApp(MSParam("doc"), MSParam(this.msObjectId), MSParam("setAction"), MSParam(ArgsAsArray(arguments)));
	},
	get calculate(){
		return MSResult(msApp.sendToApp(MSParam("doc"), MSParam(this.msObjectId), MSParam("getCalculate"), MSParam(ArgsAsArray(arguments))));
	},
    set calculate(val){
		msApp.sendToApp(MSParam("doc"), MSParam(this.msObjectId), MSParam("setCalculate"), MSParam(ArgsAsArray(arguments)));
	},
	calculateNow: function(){
		
		msApp.sendToApp(MSParam("doc"), MSParam(this.msObjectId), MSParam("calculateNow"), MSParam(ArgsAsArray(arguments)));
	},
	get pageNum(){
		return MSResult(msApp.sendToApp(MSParam("doc"), MSParam(this.msObjectId), MSParam("getPageNum"), MSParam(ArgsAsArray(arguments))));
	},
    set pageNum(val){
		msApp.sendToApp(MSParam("doc"), MSParam(this.msObjectId), MSParam("setPageNum"), MSParam(ArgsAsArray(arguments)));
    },
	get numPages() {
        return MSResult(msApp.sendToApp(MSParam("doc"), MSParam(this.msObjectId), MSParam("getNumPages"), MSParam(ArgsAsArray(arguments))));
    },
	get external(){
		return false;
	},
	fieldExists: function(){
		return MSResult(msApp.sendToApp(MSParam("doc"), MSParam(this.msObjectId), MSParam("fieldExists"), MSParam(ArgsAsArray(arguments))));
    },
    resetForm: function () {
        return MSResult(msApp.sendToApp(MSParam("doc"), MSParam(this.msObjectId), MSParam("resetForm"), MSParam(ArgsAsArray(arguments))));
    },
    get numFields() {
        return MSResult(msApp.sendToApp(MSParam("doc"), MSParam(this.msObjectId), MSParam("getNumFields"), MSParam(ArgsAsArray(arguments))));
    },
    getNthFieldName: function () {
        return MSResult(msApp.sendToApp(MSParam("doc"), MSParam(this.msObjectId), MSParam("getNthFieldName"), MSParam(ArgsAsArray(arguments))));
    }, print: function () {
        return MSResult(msApp.sendToApp(MSParam("doc"), MSParam(this.msObjectId), MSParam("print"), MSParam(ArgsAsArray(arguments))));
    },
}


var DocProxyHandler= function(objThis){
    this.getGlobalThis= function(){return objThis;};
};


DocProxyHandler.prototype = {

get: function(obj, prop) {
    if ((prop != 'app') && (prop != 'color') && (prop != 'console') && (prop != 'global') && (prop != 'event') && (prop in obj))
		return obj[prop];
	else if(prop in this.getGlobalThis())
		return this.getGlobalThis()[prop];
  },
}

