var util= {};

util.printf= function(){
	
	var res= "";
	var format= arguments[0];
	var idxArgument= 1;
	
	for(;;){
		var idx= format.indexOf("%");
		if(idx<0){
			res+=format;
			break;
		}
		
		res+= format.substr(0, idx);
		format= format.substr(++idx);		
		var arg= arguments[idxArgument++];

		var nDecSep;
		if(format.charAt(0)==','){
			nDecSep= format.charAt(1);
			format= format.substr(2);
		}
		//console.log("nDecSep= " + nDecSep);
		
		var cFlags;
		if(format.charAt(0)=='+'){
			cFlags= format.charAt(0);
			format= format.substr(1);
		}
		else if(format.charAt(0)==' '){
			cFlags= format.charAt(0);
			format= format.substr(1);
		}
		else if(format.charAt(0)=='0'){
			cFlags= format.charAt(0);
			format= format.substr(1);
		}
		else if(format.charAt(0)=='#'){
			cFlags= format.charAt(0);
			format= format.substr(1);
		}
		
		//console.log("cFlags= " + cFlags);

		
		var nWidth;
		if(format.charAt(0)>'0' && format.charAt(0)<'9'){
			nWidth= format.charAt(0)-'0';
			format= format.substr(1);
			if(format.charAt(0)>'0' && format.charAt(0)<'9'){
				width*=10;
				nWidth+= format.charAt(0)-'0';
				format= format.substr(1);
			}
			
			//console.log("nWidth= " + nWidth);
		}
		
		var nPrecision;
		if(format.charAt(0)=='.'){
			nPrecision= format.charAt(1)-'0';
			format= format.substr(2);
		}
		
		var cConvChar= format.charAt(0);
		format= format.substr(1);
		switch(cConvChar){
		case 'f':
			res+= new Number(arg).toFixed(nPrecision);
			break;
		case 'd':
			res+= new Number(arg).toFixed();
			break;
		case 'x':
			res+= new Number(arg);
			break;
		case 's':
			res += arg;
			break;
		default:
			throw new Error("Invalid printf cConvChar: " + cConvChar);
		}
	}
	
	return res;
	
};

util.printd= function(cFormat, date)
{
	var ch= undefined;
	var len= 0;
	var res= "";
	
	var tmp;

	var printComponent= function(type, len){
		switch(type)
		{
			case 'm':
				switch(len)
				{
					case 2:
					{
						var m= date.getMonth()+1;
						if(m<10)
							res+="0";
						res+= m;
						break;
					}
					case 3:
					{
						const monthShortNames = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
						res += monthShortNames[date.getMonth()];
						break;
					}
					case 4:
					{
						const monthLongNames = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
						res += monthLongNames[date.getMonth()];
						break;
					}
					default:
						res+= date.getMonth()+1;
						break;
				}
				break;
            case 'd':
                switch (len) {
                    case 2:
                        {
                            var d = date.getDate();
                            if (d < 10)
                                res += "0";
                            res += d;
                            break;
                        }
                    case 3:
                        {
                            const daysShortNames = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];
                            res += daysShortNames[date.getDay() ];
                            break;
                        }
                    case 4:
                        {
                            constdaysLongNames = ['Sunday', 'Monday', 'Tuesday', 'Wednesday ', 'Thursday ', 'Friday ', 'Saturday '];
                            res += daysLongNames[date.getDay()];
                            break;
                        }
                    default:
                        res += date.getDate();
                        break;
                }

                        break;
                
			case 'y':
				if(len==2)
					res+= date.getFullYear() %100;
				else
					res+= date.getFullYear();
				break;
			case 'H':
			    if(len==2)
                {
                    var d= date.getHours();
                    if(d<10)
                        res+="0";
                    res+= d;
                }
                else
                    res+= date.getHours();
                break;
			case 'h':
				tmp = date.getHours();
				if(tmp>12)
					tmp-=12;
				res+= tmp;
				break;
            case 'M':
                if(len==2)
                {
                    var d= date.getMinutes();
                    if(d<10)
                        res+="0";
                    res+= d;
                }
                else
                    res+= date.getMinutes();
                break;
            case 's':
                if(len==2)
                {
                    var d= date.getSeconds();
                    if(d<10)
                        res+="0";
                    res+= d;
                }
                else
                    res+= date.getSeconds();
                break;
			case 't':
				if(len=2)
				{
					if(date.getHours()>=12)
						res+="pm"
					else
						res+="am"
					break;
				}
				
			default:
				while(len--)
					res+= type;
				break;
		}
		
		return res;
	};
	
	for(pos= 0; pos<cFormat.length; pos++)
	{
		if(ch=='\\')
		{
			res+= cFormat.charAt(pos);
			ch= undefined;
			len= 0;
		}
		else if(ch==cFormat.charAt(pos))
		{
			len++;
		}
		else
		{
			printComponent(ch, len);
			ch= cFormat.charAt(pos);
			len= 1;
		}		
	}	
	
	printComponent(ch, len);
	return res;
}

 util.printx = function (fmt, val)
 {
	function convertCase(str, cmd)
	{
		switch (cmd)
		{
			case '>': return str.toUpperCase();
			case '<': return str.toLowerCase();
			default: return str;
		}
	}
	var cs = '=';
	var res = '';
	var i, m;
	var length = fmt ? fmt.length : 0;
	for (i = 0; i < length; ++i)
	{
		switch (fmt.charAt(i))
		{
			case '\\':
				if (++i < length)
					res += fmt.charAt(i);
				break;
			case 'X':
				m = val.match(/\w/);
				if (m)
				{
					res += convertCase(m[0], cs);
					val = val.replace(/^\W*\w/, '');
				}
                break;
			case 'A':
				m = val.match(/[A-Za-z]/);
				if (m)
				{
					res += convertCase(m[0], cs);
					val = val.replace(/^[^A-Za-z]*[A-Za-z]/, '');
				}
				break;
			case '9':
				m = val.match(/\d/);
				if (m)
				{
					res += m[0];
					val = val.replace(/^\D*\d/, '');
				}
				break;
			case '*':
                res += convertCase(val, cs);
				val = '';
				break;
			case '?':
				if (val)
				{
					res += convertCase(val.charAt(0), cs);
					val = val.substring(1);
				}
				break;
			case '=':
			case '>':
			case '<':
				cs = fmt.charAt(i);
				break;
			default:
				res += convertCase(fmt.charAt(i), cs);
				break;
		}
	}
	return res;
}
