precision mediump float;

uniform sampler2D  sTexture;
uniform mediump vec2  TextureSize;
uniform mediump float TimeParameter;

varying mediump vec2   TexCoord;

void main()
{
    gl_FragColor = texture2D(sTexture, TexCoord);
    
    float deltaT = 2.0 * TimeParameter; // TimeParameter is in [0.0, 1.0]
    float deltaX = TexCoord.x / TextureSize.x;
    float deltaY = 1.0 - TexCoord.y / TextureSize.y;
    
    gl_FragColor.a = pow(clamp(1.0 - (deltaT - (deltaX + deltaY)/2.0), 0.0, 1.0), 2.0);
}
