precision mediump float;

uniform sampler2D  sTexture;
uniform mediump vec2  TextureSize;
uniform mediump float TimeParameter;

varying mediump vec2   TexCoord;

void main()
{
    gl_FragColor = texture2D(sTexture, TexCoord);
    
    float pi = radians(180.0);
    float deltaT = TimeParameter * pi * 1.25; //deltaT is in [0, 1.25 * pi], TimeParameter is in [0.0, 1.0]
    vec2 center = TextureSize/2.0;
    vec2 pointVect = TexCoord - center;
    float angle = atan(abs(pointVect.x), pointVect.y);
    
    gl_FragColor.a = pow(clamp(1.0 - 5.0 * (deltaT - angle)/pi, 0.0, 1.0), 2.0);
}
